#include    "platform.h"
#include    "action.h"

#include    "eth.h"
#include    "htm.h"
#include    "uart.h"



/* ==========================================================================
   Action
   - insert data from sensors to HTML pages

  id_message
 ------------
 0x00 - 0x07 = inputs
 0x10 - 0x17 = outputs

 0x30 - MyIP
 0x31 - MyMAC
 0x32 - YourIP
 0x33 - YourMAC
*/
unsigned char insert_data (unsigned int buf_point, unsigned char id_message) {
  unsigned char number_up = 0;
  unsigned char chtmpa;

  switch (id_message) {
		case 0x00:                                                  // IN 1
      if (RA0) {
		    write_select(buf_point);
		    number_up = 7;
			}
		break;

		case 0x01:                                                  // IN 2
      if (RA1) {
		    write_select(buf_point);
		    number_up = 7;
			}
		break;

		case 0x02:                                                  // IN 3
      if (RA2) {
		    write_select(buf_point);
		    number_up = 7;
			}
		break;

		case 0x03:                                                  // IN 4
      if (RA3) {
		    write_select(buf_point);
		    number_up = 7;
			}
		break;

		case 0x04:                                                  // IN 5
      if (RA4) {
		    write_select(buf_point);
		    number_up = 7;
			}
		break;

		case 0x05:                                                  // IN 6
      if (RA5) {
		    write_select(buf_point);
		    number_up = 7;
			}
		break;

		case 0x06:                                                  // IN 7
      if (RE0) {
		    write_select(buf_point);
		    number_up = 7;
			}
		break;

		case 0x07:                                                  // IN 8
      if (RE1) {
		    write_select(buf_point);
		    number_up = 7;
			}
		break;

		case 0x10:                                                  // OUT 0
      if (RC0) {
		    write_select(buf_point);
		    number_up = 7;
			}
		break;

		case 0x11:                                                  // OUT 1
      if (RC1) {
		    write_select(buf_point);
		    number_up = 7;
			}
		break;

		case 0x12:                                                  // OUT 2
      if (RC2) {
		    write_select(buf_point);
		    number_up = 7;
			}
		break;

		case 0x13:                                                  // OUT 3
      if (RC3) {
		    write_select(buf_point);
		    number_up = 7;
			}
		break;

		case 0x14:                                                  // OUT 4
      if (RD0) {
		    write_select(buf_point);
		    number_up = 7;
			}
		break;

		case 0x15:                                                  // OUT 5
      if (RD1) {
		    write_select(buf_point);
		    number_up = 7;
			}
		break;

		case 0x16:                                                  // OUT 6
      if (RD2) {
		    write_select(buf_point);
		    number_up = 7;
			}
		break;

		case 0x17:                                                  // OUT 7
      if (RD3) {
		    write_select(buf_point);
		    number_up = 7;
			}
		break;



    case 0x30:                                             // MyIP
      number_up = write_dec(myip[0], buf_point);
      chtmpa = number_up + 1;
      buf_point += number_up;
      buffer[buf_point] = 0x2E;
      buf_point++;
      number_up = write_dec(myip[1], buf_point);
      chtmpa += (number_up + 1);
      buf_point += number_up;
      buffer[buf_point] = 0x2E;
      buf_point++;
      number_up = write_dec(myip[2], buf_point);
      chtmpa += (number_up + 1);
      buf_point += number_up;
      buffer[buf_point] = 0x2E;
      buf_point++;
      number_up = write_dec(myip[3], buf_point);
      chtmpa += number_up;
      number_up = chtmpa;
    break;

    case 0x31:                                             // MyMAC
      chtmpa = 0;
      while(chtmpa <= 4) {
        write_hex(mymac[chtmpa], buf_point);
        buf_point += 2;
        buffer[buf_point] = 0x2D;
        buf_point++;
        chtmpa++;
			}
			write_hex(mymac[chtmpa], buf_point);
      number_up = 17;
    break;

    case 0x32:                                             // YourIP
      number_up = write_dec(buffer[26], buf_point);
      chtmpa = number_up + 1;
      buf_point += number_up;
      buffer[buf_point] = 0x2E;
      buf_point++;
      number_up = write_dec(buffer[27], buf_point);
      chtmpa += (number_up + 1);
      buf_point += number_up;
      buffer[buf_point] = 0x2E;
      buf_point++;
      number_up = write_dec(buffer[28], buf_point);
      chtmpa += (number_up + 1);
      buf_point += number_up;
      buffer[buf_point] = 0x2E;
      buf_point++;
      number_up = write_dec(buffer[29], buf_point);
      chtmpa += number_up;
      number_up = chtmpa;
    break;

    case 0x33:                                             // YourMAC
      chtmpa = 6;
      while(chtmpa <= 10) {
        write_hex(buffer[chtmpa], buf_point);
        buf_point += 2;
        buffer[buf_point] = 0x2D;
        buf_point++;
        chtmpa++;
			}
			write_hex(mymac[chtmpa], buf_point);
      number_up = 17;
    break;
  }
  return number_up;
}



/* ==========================================================================
   write long number
   - convert to ASCII
*/
unsigned char write_lng (unsigned long countsendpacket, unsigned int buf_point) {
  unsigned char chtmpa, chtmpb, chtmpc;

  chtmpb = 0;
  chtmpc = 0;
  chtmpa = (unsigned char)((unsigned long)countsendpacket / 1000000);
  if (chtmpa || chtmpb) {
    buffer[buf_point] = (chtmpa + 0x30);
    buf_point++;
    countsendpacket -= (unsigned long)((unsigned long)chtmpa * 1000000);
    chtmpb = 1;
    chtmpc++;
  }
  chtmpa = (unsigned char)((unsigned long)countsendpacket / 100000);
  if (chtmpa || chtmpb) {
    buffer[buf_point] = (chtmpa + 0x30);
    buf_point++;
    countsendpacket -= (unsigned long)((unsigned long)chtmpa * 100000);
    chtmpb = 1;
    chtmpc++;
  }
  chtmpa = (unsigned char)((unsigned long)countsendpacket / 10000);
  if (chtmpa || chtmpb) {
    buffer[buf_point] = (chtmpa + 0x30);
    buf_point++;
    countsendpacket -= (unsigned long)((unsigned long)chtmpa * 10000);
    chtmpb = 1;
    chtmpc++;
  }
  chtmpa = (unsigned char)((unsigned long)countsendpacket / 1000);
  if (chtmpa || chtmpb) {
    buffer[buf_point] = (chtmpa + 0x30);
    buf_point++;
    countsendpacket -= (unsigned long)((unsigned long)chtmpa * 1000);
    chtmpb = 1;
    chtmpc++;
  }
  chtmpa = (unsigned char)((unsigned long)countsendpacket / 100);
  if (chtmpa || chtmpb) {
    buffer[buf_point] = (chtmpa + 0x30);
    buf_point++;
    countsendpacket -= (unsigned long)((unsigned long)chtmpa * 100);
    chtmpb = 1;
    chtmpc++;
  }
  chtmpa = (unsigned char)((unsigned long)countsendpacket / 10);
  if (chtmpa || chtmpb) {
    buffer[buf_point] = (chtmpa + 0x30);
    buf_point++;
    countsendpacket -= (unsigned long)((unsigned long)chtmpa * 10);
    chtmpb = 1;
    chtmpc++;
  }
  buffer[buf_point] = ((unsigned char)countsendpacket + 0x30);
  chtmpc++;

  return(chtmpc);
}



/* ==========================================================================
   write decimal number
*/
unsigned char write_dec(unsigned char value, unsigned int buf_point) {
  unsigned char chtmpa, chtmpb, chtmpc;
  chtmpa = value / 100;
  chtmpb = 0;
  chtmpc = 0;
  if (chtmpa || chtmpb) {
    buffer[buf_point] = (chtmpa + 0x30);
    buf_point++;
    value -= (chtmpa * 100);
    chtmpb = 1;
    chtmpc++;
  }
  chtmpa = value / 10;
  if (chtmpa || chtmpb) {
    buffer[buf_point] = (chtmpa + 0x30);
    buf_point++;
    value -= (chtmpa * 10);
    chtmpb = 1;
    chtmpc++;
  }
  chtmpa = value;
  buffer[buf_point] = (chtmpa + 0x30);
  chtmpc++;
  return(chtmpc);
}



/* ==========================================================================
   write hexa number
*/
void write_hex(unsigned char value, unsigned int buf_point) {
  unsigned char chtmpa;
  chtmpa = value / 16;
  if (chtmpa >= 10) {
    buffer[buf_point] = (chtmpa + 0x37);
  } else {
    buffer[buf_point] = (chtmpa + 0x30);
  }
  buf_point++;
  value -= (chtmpa * 16);
  chtmpa = value;
  if (chtmpa >= 10) {
    buffer[buf_point] = (chtmpa + 0x37);
  } else {
    buffer[buf_point] = (chtmpa + 0x30);
  }
}



/* ==========================================================================
   write "checked"
*/
void write_select (unsigned int buf_point) {
  buffer[buf_point] = 'c';                            // checked
  buf_point++;
  buffer[buf_point] = 'h';
  buf_point++;
  buffer[buf_point] = 'e';
  buf_point++;
  buffer[buf_point] = 'c';
  buf_point++;
  buffer[buf_point] = 'k';
  buf_point++;
  buffer[buf_point] = 'e';
  buf_point++;
  buffer[buf_point] = 'd';
}



/* ==========================================================================
   Updates outputs
*/
void update_out(unsigned int ind) {

  PORTC &= 0xF0;
  PORTD &= 0xF0;

  while (buffer[ind] == 'O') {
		out_inc(buffer[ind + 1]);
		ind += 5;
	}
}



/* ==========================================================================
   local function for update outputs
*/
void out_inc (unsigned char value) {
	switch (value) {
		case '0':
		  RC0 = 1;
		break;

		case '1':
		  RC1 = 1;
		break;

		case '2':
		  RC2 = 1;
		break;

		case '3':
		  RC3 = 1;
		break;

		case '4':
		  RD0 = 1;
		break;

		case '5':
		  RD1 = 1;
		break;

		case '6':
		  RD2 = 1;
		break;

		case '7':
		  RD3 = 1;
		break;

	}
}



