#include    "platform.h"
#include    "ip.h"

#include    "eth.h"
#include    "udp.h"
#include    "icmp.h"
#include    "tcp.h"


void ip_in (unsigned int len) {
  struct IP_header *ip;
  ip = (struct IP_header *) &buffer[14];

  if (Checkmymac() || Checkbroadcast()) {
    switch (ip->IP_protocol) {
      case TYPE_TCP:
        tcp (buffer);                           // TCP
      break;

      case TYPE_ICMP:
        icmp (len,buffer);                      // ICMP
      break;

      case TYPE_UDP:
        udp (buffer);                           // UDP
      break;
    }
	}
}


/* ==========================================================================
   Create IP block
*/
void ip (unsigned char *buff) {
  unsigned int sum;
  unsigned char a;
  struct IP_header *ip;
  ip = (struct IP_header *) &buff[14];

  for (a = 0; a < 4; a++) {                           // swap IP address
    ip->IP_destIp[a] = ip->IP_sourceIp[a];
    ip->IP_sourceIp[a] = myip[a];
  }

  ip->IP_checksum = 0;                                // checksum calculate
  sum = checksum(&buff[14], 0, 20);
  ip->IP_checksum = ((sum & 0xFF00) >> 8) | ((sum & 0x00FF) << 8);
}



/* ==========================================================================
   IP checksum calculate
*/
int checksum (unsigned char *pointer,unsigned long result32,unsigned int result16) {
  unsigned int result16_1 = 0x0000;
  unsigned char DataH;
  unsigned char DataL;

  while (result16 > 1) {
    DataH =* pointer++;
    DataL =* pointer++;
    result16_1 = ((DataH << 8) + DataL);
    result32 = result32 + result16_1;
    result16 -= 2;
  }

  if (result16 > 0) {
    DataH=*pointer;
    result16_1 = (DataH << 8);
    result32 = result32 + result16_1;
  }

  result32 = ((result32 & 0x0000FFFF) + ((result32 & 0xFFFF0000) >> 16));
  result32 = ((result32 & 0x0000FFFF) + ((result32 & 0xFFFF0000) >> 16));
  result16 =~ (result32 & 0x0000FFFF);

  return (result16);
}




