#include    "platform.h"

#include    "eth.h"
#include    "uart.h"

void cpu_init (void);

__CONFIG(1,0xFEFF);
__CONFIG(2,0xFEF2);
__CONFIG(3,0xFFFF);
__CONFIG(4,0xFFFB);
__CONFIG(5,0xFFFF);
__CONFIG(6,0xFFFF);
__CONFIG(7,0xFFFF);


__EEPROM_DATA(0xAB,0xBC,0x6F,0x55,0x1C,0xC2, 0x00, 0x00);        // MAC address

__EEPROM_DATA(0xC0,0xA8,0x00,0x64, 0x00, 0x00, 0x00, 0x00);        // IP address and netmask


/* ==========================================================================
   main application entry point
*/
void main (void) {
  cpu_init();                                         // cpu hardware init
  eth_init();                                         // stack init

  for (;;) {
    eth_proc();                                       // ethernet

    uart_refresh();                                   // uart

    CLRWDT();
  }
}



/* ==========================================================================
   cpu hardware initialization
*/
void cpu_init (void) {

  WDTCON = 1;                                         // watchdog is ON
  CMCON = 0x7;                                        // compare disable
  PORTC = PORTD = 0;
  TRISC = TRISD = 0xF0;
  ADCON0 = 0x81;
  ADCON1 = 0xCE;

  uart_init();
}



